package xyz.stachel.bonzotimer;

import net.fabricmc.fabric.api.client.rendering.v1.IdentifiedLayer;
import net.fabricmc.fabric.api.client.rendering.v1.LayeredDrawerWrapper;
import net.minecraft.client.MinecraftClient;
import net.minecraft.client.gui.DrawContext;
import net.minecraft.client.render.RenderTickCounter;
import net.minecraft.client.util.Window;
import net.minecraft.client.util.math.MatrixStack;
import net.minecraft.text.Text;
import net.minecraft.util.Colors;
import net.minecraft.util.Identifier;

class Renderer {

  void onRender(LayeredDrawerWrapper wrapper) {
    wrapper.attachLayerAfter(IdentifiedLayer.OVERLAY_MESSAGE, Identifier.of("bonzotimer", "timer"), Renderer::render);
  }

  public static void render(DrawContext context, RenderTickCounter tickCounter) {
    Timer.getInstance().ifPresent(timer -> {
      String s = String.format("%1.1f s", (float) timer.remaining() / 20);
      final Window win = MinecraftClient.getInstance().getWindow();
      MatrixStack m = context.getMatrices();
		  m.push();
      m.scale(1, 1, 0);
      context.drawCenteredTextWithShadow(
        MinecraftClient.getInstance().textRenderer,
        Text.of(s),
        win.getScaledWidth()/2,
        win.getScaledHeight()/4,
        Colors.RED
      );
      m.pop();
    });
  }
}
